package reverse;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;


/**
 * @author Nikita Doschennikov (me@fymio.us)
 */
public class ReverseRotate {
    public static void main(String[] args) throws IOException {
        FastScanner sc = new FastScanner();
        int[][] lines = new int[8][];
        int linesCount = 0;
        int maxCols = 0;

        while (sc.hasNextLine()) {
            int[] line = new int[8];
            int count = 0;

            while (sc.hasNextInt()) {
                if (count >= line.length) {
                    line = Arrays.copyOf(line, line.length * 2);
                }
                line[count++] = sc.nextInt();
            }
            sc.nextLine();

            line = Arrays.copyOf(line, count);

            if (linesCount >= lines.length) {
                lines = Arrays.copyOf(lines, lines.length * 2);
            }
            lines[linesCount++] = line;

            if (count > maxCols) {
                maxCols = count;
            }
        }


        PrintWriter out = new PrintWriter(System.out);

        for (int j = 0; j < maxCols; j++) {
            for (int i = linesCount - 1; i >= 0; i--) {
                if (lines[i].length > j) {
                    out.print(lines[i][j] + " ");
                }
            }
            out.println();
        }

        out.flush();
    }
}
